Subject: Re: bug#41994: Emacs on Apple ARM devices

From: Alan Third <[email-masked]>
Date: Fri, 14 Aug 2020 22:11:46 +0200 (CEST)

On Fri, Aug 14, 2020 at 04:15:40PM +0200, Robert Pluim wrote:
> >>>>> On Fri, 14 Aug 2020 02:17:18 -0700, Stefan Kangas <[email-masked]> said:
> 
>     Stefan> Roland Kaufmann <[email-masked]> writes:
>     >> Code generation on Apple's ARM devices is mostly similar to MacOS, except that
>     >> they expect a code signature section, which to avoid wasting too many bytes, are
>     >> not aligned on page size as with code, but rather to nearest 16 bytes. In
>     >> addition, the ARM compiler will also emit some relative pointer relocation
>     >> records, which it seems can be safely ignored as sections aren't rearranged.
>     >> 
>     >> This changeset implements those changes on the Mach-O dumper so that Emacs can
>     >> be compiled for ARM devices. With the ongoing convergence between the MacOS and
>     >> iOS platform, and the increasing importance of code-signing in later MacOS
>     >> versions, I think it could be nice to mainline these changes.
>     >> 
>     >> Since these sections do not occur in current MacOS builds - otherwise they would
>     >> generate errors for being unknown - the changes should not impact existing
>     >> places where Emacs build, and it would not work on iOS without to begin with.
>     >> 
>     >> Hat tip to Aaron Griffith for sharing his knowledge.
> 
>     Stefan> This series of patches was submitted 8 weeks ago, but never got a reply
>     Stefan> at the time.
> 
>     Stefan> Could someone with more knowledge about this please help review it?
> 
> Are these patches even still needed now that emacs-27 has a portable
> dumper?

That's what I was wondering (although to be honest I never even
noticed there were patches attached).

I suspect the patch to configure.ac might be needed even for the
pdumpder?
-- 
Alan Third